<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;
use FM\Traits\TQuery;

class Fm00031000TarefasVistoriasContratoFactory
{

    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    // FUNÇÕES DA TAB DE TAREFAS
    public function getContratosTarefas()
    {

        $sql = "SELECT  ROWNUM AS ID,  CONTRATOS.* 
        FROM (SELECT DISTINCT FCM_CHECKLISTAGEND.NRSEQCONTRATO, FCT_CONTRATO.NRCONTRATOFCT, FCT_TIPOMEDIDASERV.DSTPMEDIDASERV, FCT_SERVICOORCA.NMSERVORCA, FCM_RELSERVITEMTAR.CDSERVORCA, 
                    FCM_RELSERVITEMTAR.CDTPMEDIDASERV, SUM(ITENS.DURACAO) AS TOTALMEDIDA
                    FROM FCM_CHECKLISTAGEND
                    JOIN FCT_CONTRATO
                      ON FCT_CONTRATO.NRSEQCONTRATO = FCM_CHECKLISTAGEND.NRSEQCONTRATO 
                    JOIN FCT_ITEMCONTRATO
                      ON FCT_ITEMCONTRATO.NRSEQCONTRATO = FCT_CONTRATO.NRSEQCONTRATO
                    JOIN FCT_SERVICOORCA
                      ON FCT_SERVICOORCA.CDSERVORCA = FCT_ITEMCONTRATO.CDSERVORCA
                    JOIN FCT_TIPOMEDIDASERV
                      ON FCT_TIPOMEDIDASERV.CDTPMEDIDASERV = FCT_ITEMCONTRATO.CDTPMEDIDASERV
                    JOIN FCM_RELSERVITEMTAR
                      ON FCM_RELSERVITEMTAR.CDSERVORCA = FCT_ITEMCONTRATO.CDSERVORCA
                     AND FCM_RELSERVITEMTAR.CDTPMEDIDASERV = FCT_ITEMCONTRATO.CDTPMEDIDASERV
                    JOIN (SELECT DISTINCT FCM_CHECKLISTAGEND.NRCHECKLISTAGEND, FCM_CHECKLISTAGEND.NRSEQCONTRATO, FCM_RELSERVITEMTAR.CDSERVORCA, FCM_RELSERVITEMTAR.CDTPMEDIDASERV, ROUND((((FCM_CHECKLISTAGEND.DTHRFINALAGEND - FCM_CHECKLISTAGEND.DTHORAAGEND) * 24) * 60), 2) AS DURACAO
                         FROM FCM_TAREFAAGEND
                         JOIN FCM_CHECKLISTAGEND 
                           ON FCM_CHECKLISTAGEND.NRCHECKLISTAGEND = FCM_TAREFAAGEND.NRCHECKLISTAGEND
                         JOIN FCT_ITEMCONTRATO
                           ON FCT_ITEMCONTRATO.NRSEQCONTRATO = FCM_CHECKLISTAGEND.NRSEQCONTRATO
                         JOIN FCM_ATIVIDADECHK 
                           ON FCM_ATIVIDADECHK.NRCHECKLIST = FCM_CHECKLISTAGEND.NRCHECKLIST
                         JOIN FCM_RELSERVITEMTAR
                           ON FCM_RELSERVITEMTAR.NRATIVIDADE = FCM_ATIVIDADECHK.NRATIVIDADE
                         JOIN FCM_ATIVIDADE
                           ON FCM_RELSERVITEMTAR.NRATIVIDADE = FCM_ATIVIDADE.NRATIVIDADE
                          AND FCM_RELSERVITEMTAR.CDSERVORCA = FCT_ITEMCONTRATO.CDSERVORCA
                          AND FCM_RELSERVITEMTAR.CDTPMEDIDASERV = FCT_ITEMCONTRATO.CDTPMEDIDASERV
                         JOIN OPERADOR
                           ON OPERADOR.CDOPERADOR = FCM_TAREFAAGEND.CDOPERADOR
                        WHERE FCM_TAREFAAGEND.IDREALIZADO = 'S') ITENS
                     ON ITENS.NRSEQCONTRATO = FCM_CHECKLISTAGEND.NRSEQCONTRATO
                     AND ITENS.CDSERVORCA = FCM_RELSERVITEMTAR.CDSERVORCA
                     AND ITENS.CDTPMEDIDASERV = FCM_RELSERVITEMTAR.CDTPMEDIDASERV
                     WHERE TO_CHAR(FCM_CHECKLISTAGEND.DTHORAAGEND, 'MM/YYYY') = TO_CHAR(SYSDATE, 'MM/YYYY') 
                    GROUP BY FCM_CHECKLISTAGEND.NRSEQCONTRATO, FCT_CONTRATO.NRCONTRATOFCT, FCT_TIPOMEDIDASERV.DSTPMEDIDASERV, FCT_SERVICOORCA.NMSERVORCA, FCM_RELSERVITEMTAR.CDSERVORCA, FCM_RELSERVITEMTAR.CDTPMEDIDASERV) CONTRATOS";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getItensTarefasContratos($parametros)
    {

        $sql = "SELECT ROWNUM AS ID, ITENS.* 
                    FROM (SELECT DISTINCT FCM_CHECKLISTAGEND.NRSEQCONTRATO, FCM_ATIVIDADE.NMATIVIDADE, FCM_TAREFAAGEND.CDOPERADOR, OPERADOR.NMOPERADOR, ROUND((((FCM_CHECKLISTAGEND.DTHRFINALAGEND - FCM_CHECKLISTAGEND.DTHORAAGEND) * 24) * 60), 2) AS DURACAO
                            FROM FCM_TAREFAAGEND
                            JOIN FCM_CHECKLISTAGEND 
                                ON FCM_CHECKLISTAGEND.NRCHECKLISTAGEND = FCM_TAREFAAGEND.NRCHECKLISTAGEND
                            JOIN FCT_ITEMCONTRATO
                                ON FCT_ITEMCONTRATO.NRSEQCONTRATO = FCM_CHECKLISTAGEND.NRSEQCONTRATO
                            JOIN FCM_ATIVIDADECHK 
                                ON FCM_ATIVIDADECHK.NRCHECKLIST = FCM_CHECKLISTAGEND.NRCHECKLIST
                            JOIN FCM_RELSERVITEMTAR
                                ON FCM_RELSERVITEMTAR.NRATIVIDADE = FCM_ATIVIDADECHK.NRATIVIDADE
                            JOIN FCM_ATIVIDADE
                                ON FCM_RELSERVITEMTAR.NRATIVIDADE = FCM_ATIVIDADE.NRATIVIDADE
                                AND FCM_RELSERVITEMTAR.CDSERVORCA = FCT_ITEMCONTRATO.CDSERVORCA
                                AND FCM_RELSERVITEMTAR.CDTPMEDIDASERV = FCT_ITEMCONTRATO.CDTPMEDIDASERV
                            JOIN OPERADOR
                                ON OPERADOR.CDOPERADOR = FCM_TAREFAAGEND.CDOPERADOR
                            WHERE FCM_TAREFAAGEND.IDREALIZADO = 'S'
                            AND FCM_RELSERVITEMTAR.CDSERVORCA = :CDSERVORCA
                            AND FCM_RELSERVITEMTAR.CDTPMEDIDASERV = :CDTPMEDIDASERV) ITENS";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametros);
    }

    public function getContratosVistoria()
    {
        $sql =  "SELECT  ROWNUM AS ID,  CONTRATOS.* 
                    FROM (SELECT DISTINCT FCM_GERENCIAMENTOCHK.NRSEQCONTRATO, FCT_CONTRATO.NRCONTRATOFCT, FCT_TIPOMEDIDASERV.DSTPMEDIDASERV, 
                                FCT_SERVICOORCA.NMSERVORCA, FCM_RELSERVITEMTAR.CDSERVORCA, 
                                FCM_RELSERVITEMTAR.CDTPMEDIDASERV, SUM(ITENS.DURACAO) AS TOTALMEDIDA
                                FROM FCM_GERENCIAMENTOCHK
                                JOIN FCT_CONTRATO
                                ON FCT_CONTRATO.NRSEQCONTRATO = FCM_GERENCIAMENTOCHK.NRSEQCONTRATO 
                                JOIN FCT_ITEMCONTRATO
                                ON FCT_ITEMCONTRATO.NRSEQCONTRATO = FCT_CONTRATO.NRSEQCONTRATO
                                JOIN FCT_SERVICOORCA
                                ON FCT_SERVICOORCA.CDSERVORCA = FCT_ITEMCONTRATO.CDSERVORCA
                                JOIN FCT_TIPOMEDIDASERV
                                ON FCT_TIPOMEDIDASERV.CDTPMEDIDASERV = FCT_ITEMCONTRATO.CDTPMEDIDASERV
                                JOIN FCM_RELSERVITEMTAR
                                ON FCM_RELSERVITEMTAR.CDSERVORCA = FCT_ITEMCONTRATO.CDSERVORCA
                                AND FCM_RELSERVITEMTAR.CDTPMEDIDASERV = FCT_ITEMCONTRATO.CDTPMEDIDASERV
                                JOIN (SELECT DISTINCT FCM_GERENCIAMENTOCHK.NRGERENCIAMENTOCHK, FCM_GERENCIAMENTOCHK.NRSEQCONTRATO, FCM_RELSERVITEMTAR.CDSERVORCA, 
                                                    FCM_RELSERVITEMTAR.CDTPMEDIDASERV, 
                                                    ROUND((((FCM_GERENCIAMENTOCHK.DTHRFINALAGEND - FCM_GERENCIAMENTOCHK.DTHORAAGEND) * 24) * 60), 2) AS DURACAO
                                    FROM FCM_TAREFAGERCHK
                                    JOIN FCM_GERENCIAMENTOCHK 
                                    ON FCM_GERENCIAMENTOCHK.NRGERENCIAMENTOCHK = FCM_TAREFAGERCHK.NRGERENCIAMENTOCHK
                                    JOIN FCT_ITEMCONTRATO
                                    ON FCT_ITEMCONTRATO.NRSEQCONTRATO = FCM_GERENCIAMENTOCHK.NRSEQCONTRATO
                                    JOIN FCM_ATIVIDADECHK 
                                    ON FCM_ATIVIDADECHK.NRCHECKLIST = FCM_GERENCIAMENTOCHK.NRCHECKLIST
                                    JOIN FCM_RELSERVITEMTAR
                                    ON FCM_RELSERVITEMTAR.NRATIVIDADE = FCM_ATIVIDADECHK.NRATIVIDADE
                                    JOIN FCM_ATIVIDADE
                                    ON FCM_RELSERVITEMTAR.NRATIVIDADE = FCM_ATIVIDADE.NRATIVIDADE
                                    AND FCM_RELSERVITEMTAR.CDSERVORCA = FCT_ITEMCONTRATO.CDSERVORCA
                                    AND FCM_RELSERVITEMTAR.CDTPMEDIDASERV = FCT_ITEMCONTRATO.CDTPMEDIDASERV
                                    JOIN OPERADOR
                                    ON OPERADOR.CDOPERADOR = FCM_TAREFAGERCHK.CDOPERADOR) ITENS
                                ON ITENS.NRSEQCONTRATO = FCM_GERENCIAMENTOCHK.NRSEQCONTRATO
                                AND ITENS.CDSERVORCA = FCM_RELSERVITEMTAR.CDSERVORCA
                                AND ITENS.CDTPMEDIDASERV = FCM_RELSERVITEMTAR.CDTPMEDIDASERV
                                WHERE TO_CHAR(FCM_GERENCIAMENTOCHK.DTHORAAGEND, 'MM/YYYY') = TO_CHAR(SYSDATE, 'MM/YYYY') 
                                GROUP BY FCM_GERENCIAMENTOCHK.NRSEQCONTRATO, FCT_CONTRATO.NRCONTRATOFCT, FCT_TIPOMEDIDASERV.DSTPMEDIDASERV, FCT_SERVICOORCA.NMSERVORCA, 
                                         FCM_RELSERVITEMTAR.CDSERVORCA, FCM_RELSERVITEMTAR.CDTPMEDIDASERV) CONTRATOS";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getItensVistoriaContrato($parametros)
    {

        $sql = "SELECT ROWNUM AS ID, ITENS.* 
                    FROM (SELECT DISTINCT FCM_GERENCIAMENTOCHK.NRSEQCONTRATO, FCM_ATIVIDADE.NMATIVIDADE, FCM_TAREFAGERCHK.CDOPERADOR, OPERADOR.NMOPERADOR, 
                            ROUND((((FCM_GERENCIAMENTOCHK.DTHRFINALAGEND - FCM_GERENCIAMENTOCHK.DTHORAAGEND) * 24) * 60), 2) AS DURACAO
                        FROM FCM_TAREFAGERCHK
                        JOIN FCM_GERENCIAMENTOCHK 
                        ON FCM_GERENCIAMENTOCHK.NRGERENCIAMENTOCHK = FCM_TAREFAGERCHK.NRGERENCIAMENTOCHK
                        JOIN FCT_ITEMCONTRATO
                        ON FCT_ITEMCONTRATO.NRSEQCONTRATO = FCM_GERENCIAMENTOCHK.NRSEQCONTRATO
                        JOIN FCM_ATIVIDADECHK 
                        ON FCM_ATIVIDADECHK.NRCHECKLIST = FCM_GERENCIAMENTOCHK.NRCHECKLIST
                        JOIN FCM_RELSERVITEMTAR
                        ON FCM_RELSERVITEMTAR.NRATIVIDADE = FCM_ATIVIDADECHK.NRATIVIDADE
                        JOIN FCM_ATIVIDADE
                        ON FCM_RELSERVITEMTAR.NRATIVIDADE = FCM_ATIVIDADE.NRATIVIDADE
                        AND FCM_RELSERVITEMTAR.CDSERVORCA = FCT_ITEMCONTRATO.CDSERVORCA
                        AND FCM_RELSERVITEMTAR.CDTPMEDIDASERV = FCT_ITEMCONTRATO.CDTPMEDIDASERV
                        JOIN OPERADOR
                        ON OPERADOR.CDOPERADOR = FCM_TAREFAGERCHK.CDOPERADOR
                        wHERE FCM_RELSERVITEMTAR.CDSERVORCA = :CDSERVORCA
                        AND FCM_RELSERVITEMTAR.CDTPMEDIDASERV = :CDTPMEDIDASERV) ITENS";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametros);
    }
}
