<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;

class LogtransfAgendFactory
{
    protected $connection;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
    }

    public function insertLogTrasnfer($param)
    {
        $sql = "INSERT INTO FCM_LOGTRANSFAGEND (NRLOGTRANSFAGEND, NRCHECKLISTAGEND, CDOPERADORORIGEM, DTHORAAGENDORIG, CDOPERADORDESTINO,
                            DTHORAAGENDDESTINO, NRORG, IDATIVO, DTINCLUSAO, DTULTATU, CDOPERREALIZATRANSF)
                    VALUES (:NRLOGTRANSFAGEND, :NRCHECKLISTAGEND, :CDOPERADORORIGEM,TO_DATE(:DTHORAAGENDORIG,'DD/MM/YYYY HH24:MI'),
                    :CDOPERADORDESTINO,TO_DATE(:DTHORAAGENDDESTINO,'DD/MM/YYYY HH24:MI'), :NRORG, 'S', SYSDATE, SYSDATE, :CDOPERREALIZATRANSF)";

        $this->connection->executeStatement($sql, $param);
    }

    public function getHistorico()
    {
        $sql = "SELECT FCM_LOGTRANSFGERCHK.NRGERENCIAMENTOCHK as id, ('Vistoria - ' || FCM_GERENCIAMENTOCHK.NMGERENCIAMENTOCHK) AS NOME, 
                       TO_CHAR(FCM_GERENCIAMENTOCHK.DTHORAAGEND, 'DD/MM/YYYY HH24:MI') as DTHORAAGEND, ORIGEM.NMOPERADOR AS FUNCORIGEM,
                       DESTINO.NMOPERADOR AS FUNCDESTINO, TO_CHAR(FCM_LOGTRANSFGERCHK.DTINCLUSAO, 'DD/MM/YYYY HH24:MI') as DTINCLUSAO, 
                       RESPDESTINOONSAVEL.NMOPERADOR AS RESPONSAVEL
                  FROM FCM_LOGTRANSFGERCHK
             LEFT JOIN FCM_GERENCIAMENTOCHK
                    ON FCM_LOGTRANSFGERCHK.NRGERENCIAMENTOCHK = FCM_GERENCIAMENTOCHK.NRGERENCIAMENTOCHK
             LEFT JOIN OPERADOR ORIGEM
                    ON FCM_LOGTRANSFGERCHK.CDOPERADORORIGEM = ORIGEM.CDOPERADOR
             LEFT JOIN OPERADOR DESTINO
                    ON FCM_LOGTRANSFGERCHK.CDOPERADORDESTINO = DESTINO.CDOPERADOR
             LEFT JOIN OPERADOR RESPDESTINOONSAVEL
                    ON FCM_LOGTRANSFGERCHK.CDOPERREALIZATRANSF = RESPDESTINOONSAVEL.CDOPERADOR
                
                UNION
                
                SELECT FCM_LOGTRANSFAGEND.NRCHECKLISTAGEND as id, FCM_CHECKLISTAGEND.NMCHECKLISTAGEND AS NOME, TO_CHAR(FCM_CHECKLISTAGEND.DTHORAAGEND, 'DD/MM/YYYY HH24:MI') as DTHORAAGEND, ORIGEM.NMOPERADOR AS FUNCORIGEM,
                        DESTINO.NMOPERADOR AS FUNCDESTINO, TO_CHAR(FCM_LOGTRANSFAGEND.DTINCLUSAO, 'DD/MM/YYYY HH24:MI') as DTINCLUSAO, RESPDESTINOONSAVEL.NMOPERADOR AS RESPONSAVEL
                  FROM FCM_LOGTRANSFAGEND
             LEFT JOIN FCM_CHECKLISTAGEND
                    ON FCM_LOGTRANSFAGEND.NRCHECKLISTAGEND = FCM_CHECKLISTAGEND.NRCHECKLISTAGEND
             LEFT JOIN OPERADOR ORIGEM
                    ON FCM_LOGTRANSFAGEND.CDOPERADORORIGEM = ORIGEM.CDOPERADOR
             LEFT JOIN OPERADOR DESTINO
                    ON FCM_LOGTRANSFAGEND.CDOPERADORDESTINO = DESTINO.CDOPERADOR
             LEFT JOIN OPERADOR RESPDESTINOONSAVEL
                    ON FCM_LOGTRANSFAGEND.CDOPERREALIZATRANSF = RESPDESTINOONSAVEL.CDOPERADOR
              ORDER BY DTINCLUSAO DESC";

        return $this->connection->executeQuery($sql)->fetchAllAssociative();
    }
}
