<?php

namespace FM\Service;

use FM\Factory\SensorDeFluxoFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;

class SensorDeFluxoService
{

    protected $SensorDeFluxoFactory;
    protected $Environment;
    protected $newCode;

    public function __construct(SensorDeFluxoFactory $SensorDeFluxoFactory, Environment $Environment, NewCode $newCode)
    {
        $this->SensorDeFluxoFactory = $SensorDeFluxoFactory;
        $this->Environment = $Environment;
        $this->newCode = $newCode;
    }

    public function getSensores()
    {
        return $this->SensorDeFluxoFactory->getSensores();
    }

    public function getInicioEDateSensor($param)
    {
        if (property_exists('IP2', $param)) {
            return [$this->SensorDeFluxoFactory->getInicioEDateSensor($param['IP']), $this->SensorDeFluxoFactory->getInicioEDateSensor($param['IP2'])];
        } else {
            return $this->SensorDeFluxoFactory->getInicioEDateSensor($param['IP']);
        }
    }

    public function sensores($dados)
    {
        $this->SensorDeFluxoFactory->insertDadosSensores(array(
            "NRSEQLEITURA" => $this->newCode->getCodeByTableName("FCM_LEITCONTPESSOAS ", $this->Environment->getNrOrg(), 1, 10, true),
            "IDMACDEVICE" => $dados["idSensor"],
            "IDSENSOR" => $dados["idSensor"], // $dadosJson['idSensor'],
            "QTPESSOASENTR" => $dados["total"], // $dadosJson['total'],
            "IPSENSOR" => $dados["ip"], // $dadosJson['ip'],
            "NRORG" =>  $this->Environment->getNrOrg(),
            "IDATIVO" => 'S',
            "OBS" => json_encode($dados)
        ));
    }

    public function getCount($param)
    {
        $ID = array(
            "IDSENSOR" => $param['IDSENSOR']
        );
        if ($param['FIRST'] == 'true') {
            if ($param['RESET'] == 'S') {
                $this->SensorDeFluxoFactory->resetCount($ID);
            }
            $this->SensorDeFluxoFactory->modifyStatusCount(array(
                "IDSENSOR" => $param['IDSENSOR'],
                "IDMONITORAMENTO" => 'S'
            ));
        }
        $responseOfTheDatabase = ($this->SensorDeFluxoFactory->getCount2($ID));
        // debugApi([count($responseOfTheDatabase)]);
        // $allValue = 0;
        // if($responseOfTheDatabase != null){
        //     $last = $this->SensorDeFluxoFactory->lastCount($ID);
        //     $lastNumber = ($last != null && count($last)) ? $last[0]["QTPESSOASENTR"] : 0;
        //     foreach($responseOfTheDatabase as $number){
        //         if(($number["QTPESSOASENTR"] == ($lastNumber + 1)) || ($number["QTPESSOASENTR"] == 1 && $lastNumber > 1)){
        //             $allValue += 1;
        //         }
        //         $lastNumber = $number["QTPESSOASENTR"];
        //     }
        // }
        // return $allValue;
        return $responseOfTheDatabase[0]['QTPESSOASENTR'];
    }

    public function stopCount($param)
    {
        $this->SensorDeFluxoFactory->modifyStatusCount(array(
            "IDSENSOR" => $param['IP'],
            "IDMONITORAMENTO" => 'N'
        ));
    }

    public function resetCount($param)
    {
        $this->SensorDeFluxoFactory->resetCount(array(
            "IDSENSOR" => $param['IP']
        ));
        $this->SensorDeFluxoFactory->modifyStatusCount(array(
            "IDSENSOR" => $param['IP'],
            "IDMONITORAMENTO" => 'N'
        ));
    }
}
